#ifndef MDD_INPUT_H
#define MDD_INPUT_H

#include <string>
#include <functional>
#include "Output.h"
#include <bits/shared_ptr.h>
#include "IUnique.h"

namespace mdd {
    class Input : public IUnique{
    private:
        std::string _prefix;
        std::string _type;
        int _appendix;

    public:
        json value;
        std::function<bool(const json &)> verification;
        std::shared_ptr <IOutput> output;


        Input(const std::string &type, int appendix, const json &default_value,
              const std::function<bool(const json &)> &verification = [](
                      const json &) { return true; });
        void setType(std::string type) override;
        std::string getType() override;
        std::string getID() override;
        std::string setPrefix(std::string prefix) override;
        std::string setAppendix(int appendix) override;
    };
}

#endif //MDD_INPUT_H
