#include "Input.h"

namespace mdd{
    Input::Input(const std::string& type, int appendix, const json& default_value,
                 const std::function<bool(const json&)>& verification) {
        _type = type;
        value = default_value;
        this->verification = std::move(verification);
        _prefix = "";
        _appendix = appendix;
    }

    void Input::setType(std::string type){
        _type = type;
    }
    std::string Input::getType(){
        return  _type;
    }
    std::string Input::getID(){
        return _prefix + "/" + _type + std::to_string(_appendix);
    }

    std::string Input::setPrefix(std::string prefix){
        _prefix = prefix;
        return getID();
    }

    std::string Input::setAppendix(int appendix){
        _appendix = appendix;
        return  getID();
    }
}